<template>
  <template v-for="line in lineitems" :key="line.concept_id">
    <tr v-on:click="show_concept(line.concept.id)" class="pointer">
      <td :style="indent" :class="'char_' + depth" v-html="show_label(line.concept)"></td>
      <template v-if="line.concept.name.length > 80">
        <td :style="indent">{{ line.concept.name.substring(0, 80) + "&hellip;" }}</td>
      </template>
      <template v-else>
        <td :style="indent">{{ line.concept.name }}</td>
      </template>
      <td>{{ line.order }}</td>

    </tr>
    <LineItems v-if="line.line_items" :lineitems="line.line_items"
               :depth="parseInt(depth) + 1" v-on:conceptClicked="show_concept"></LineItems>
  </template>
</template>

<script>
import SharedMethods from "components/SharedMethods";

export default {
  name: "LineItems",
  emits: ["conceptClicked"],
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  props: {
    lineitems: undefined,
    depth: undefined,
  },
  computed: {
    indent() {
      return `padding-left: ${parseInt(this.depth) * 10 + 5}px;`
    }
  },
  methods: {
    show_concept: function (concept_id) {
      this.$emit('conceptClicked', concept_id)
    },
  }
}
</script>

<style scoped lang="scss">
td, th {
  border: 1px solid $blue-grey;
  padding: 4px 5px;
}

tr.pointer:hover {
  background-color: $list_selected_bg;
  opacity: 0.8;
  color: white;
}

tr.pointer:hover td {
  background: transparent;
}

.pointer {
  cursor: pointer;
}

tr.pointer .active,
.active > .detail_bg {
  background-color: transparent;
}

tbody tr:nth-child(even) {
  background-color: $blue-grey-1;
}
.char_1:before {
  content: "»";
  margin-left: -6px;
  margin-right: 2px;
}
.char_2:before {
  content: " »";
  margin-left: -11px;
  margin-right: 2px;
}
.char_3:before {
  content: " »";
  margin-left: -16px;
  margin-right: 2px;
}
</style>
